79350f79d8
Resolves: #2137584,#2138081,#2141979
252 lines
9.0 KiB
Diff
252 lines
9.0 KiB
Diff
From 680d2b33d3b2a0bed17c2c1594690155bdb910bb Mon Sep 17 00:00:00 2001
|
|
From: Frantisek Sumsal <frantisek@sumsal.cz>
|
|
Date: Tue, 1 Nov 2022 20:47:37 +0100
|
|
Subject: [PATCH] test: add a couple of sanity tests for systemctl
|
|
|
|
(cherry picked from commit d16684fe13e1d56e55df19b57b6c01b9a9303086)
|
|
|
|
Related #2138081
|
|
---
|
|
test/units/testsuite-26.sh | 209 +++++++++++++++++++++++++++++++++++--
|
|
1 file changed, 202 insertions(+), 7 deletions(-)
|
|
|
|
diff --git a/test/units/testsuite-26.sh b/test/units/testsuite-26.sh
|
|
index ad08415317..b83f85917b 100755
|
|
--- a/test/units/testsuite-26.sh
|
|
+++ b/test/units/testsuite-26.sh
|
|
@@ -3,32 +3,227 @@
|
|
set -eux
|
|
set -o pipefail
|
|
|
|
+at_exit() {
|
|
+ if [[ -v UNIT_NAME && -e "/usr/lib/systemd/system/$UNIT_NAME" ]]; then
|
|
+ rm -fv "/usr/lib/systemd/system/$UNIT_NAME"
|
|
+ fi
|
|
+}
|
|
+
|
|
+trap at_exit EXIT
|
|
+
|
|
+# Create a simple unit file for testing
|
|
+# Note: the service file is created under /usr on purpose to test
|
|
+# the 'revert' verb as well
|
|
+UNIT_NAME="systemctl-test-$RANDOM.service"
|
|
+cat >"/usr/lib/systemd/system/$UNIT_NAME" <<\EOF
|
|
+[Unit]
|
|
+Description=systemctl test
|
|
+
|
|
+[Service]
|
|
+ExecStart=sleep infinity
|
|
+ExecReload=true
|
|
+
|
|
+# For systemctl clean
|
|
+CacheDirectory=%n
|
|
+ConfigurationDirectory=%n
|
|
+LogsDirectory=%n
|
|
+RuntimeDirectory=%n
|
|
+StateDirectory=%n
|
|
+
|
|
+[Install]
|
|
+WantedBy=multi-user.target
|
|
+EOF
|
|
+
|
|
+# Configure the preset setting for the unit file
|
|
+mkdir /run/systemd/system-preset/
|
|
+echo "disable $UNIT_NAME" >/run/systemd/system-preset/99-systemd-test.preset
|
|
+
|
|
+systemctl daemon-reload
|
|
+
|
|
+# Argument help
|
|
+systemctl --state help
|
|
+systemctl --signal help
|
|
+systemctl --type help
|
|
+
|
|
+# list-dependencies
|
|
+systemctl list-dependencies systemd-journald
|
|
+systemctl list-dependencies --after systemd-journald
|
|
+systemctl list-dependencies --before systemd-journald
|
|
+systemctl list-dependencies --after --reverse systemd-journald
|
|
+systemctl list-dependencies --before --reverse systemd-journald
|
|
+systemctl list-dependencies --plain systemd-journald
|
|
+
|
|
+# list-* verbs
|
|
+systemctl list-units
|
|
+systemctl list-units --recursive
|
|
+systemctl list-units --type=socket
|
|
+systemctl list-units --type=service,timer
|
|
+systemctl list-units --legend=yes -a "systemd-*"
|
|
+systemctl list-units --state=active
|
|
+systemctl list-units --with-dependencies systemd-journald.service
|
|
+systemctl list-units --with-dependencies --after systemd-journald.service
|
|
+systemctl list-units --with-dependencies --before --reverse systemd-journald.service
|
|
+systemctl list-sockets
|
|
+systemctl list-sockets --legend=no -a "*journal*"
|
|
+systemctl list-sockets --show-types
|
|
+systemctl list-sockets --state=listening
|
|
+systemctl list-timers -a -l
|
|
+systemctl list-unit-files
|
|
+systemctl list-unit-files "*journal*"
|
|
+systemctl list-jobs
|
|
+systemctl list-jobs --after
|
|
+systemctl list-jobs --before
|
|
+systemctl list-jobs --after --before
|
|
+systemctl list-jobs "*"
|
|
+
|
|
+# Basic service management
|
|
+systemctl start --show-transaction "$UNIT_NAME"
|
|
+systemctl status -n 5 "$UNIT_NAME"
|
|
+systemctl is-active "$UNIT_NAME"
|
|
+systemctl reload -T "$UNIT_NAME"
|
|
+systemctl restart -T "$UNIT_NAME"
|
|
+systemctl try-restart --show-transaction "$UNIT_NAME"
|
|
+systemctl try-reload-or-restart --show-transaction "$UNIT_NAME"
|
|
+systemctl kill "$UNIT_NAME"
|
|
+(! systemctl is-active "$UNIT_NAME")
|
|
+systemctl restart "$UNIT_NAME"
|
|
+systemctl is-active "$UNIT_NAME"
|
|
+systemctl restart "$UNIT_NAME"
|
|
+systemctl stop "$UNIT_NAME"
|
|
+(! systemctl is-active "$UNIT_NAME")
|
|
+
|
|
+# enable/disable/preset
|
|
+(! systemctl is-enabled "$UNIT_NAME")
|
|
+systemctl enable "$UNIT_NAME"
|
|
+systemctl is-enabled -l "$UNIT_NAME"
|
|
+# We created a preset file for this unit above with a "disable" policy
|
|
+systemctl preset "$UNIT_NAME"
|
|
+(! systemctl is-enabled "$UNIT_NAME")
|
|
+systemctl reenable "$UNIT_NAME"
|
|
+systemctl is-enabled "$UNIT_NAME"
|
|
+systemctl preset --preset-mode=enable-only "$UNIT_NAME"
|
|
+systemctl is-enabled "$UNIT_NAME"
|
|
+systemctl preset --preset-mode=disable-only "$UNIT_NAME"
|
|
+(! systemctl is-enabled "$UNIT_NAME")
|
|
+systemctl enable --runtime "$UNIT_NAME"
|
|
+[[ -e "/run/systemd/system/multi-user.target.wants/$UNIT_NAME" ]]
|
|
+systemctl is-enabled "$UNIT_NAME"
|
|
+systemctl disable "$UNIT_NAME"
|
|
+# The unit should be still enabled, as we didn't use the --runtime switch
|
|
+systemctl is-enabled "$UNIT_NAME"
|
|
+systemctl disable --runtime "$UNIT_NAME"
|
|
+(! systemctl is-enabled "$UNIT_NAME")
|
|
+
|
|
+# mask/unmask/revert
|
|
+systemctl disable "$UNIT_NAME"
|
|
+[[ "$(systemctl is-enabled "$UNIT_NAME")" == disabled ]]
|
|
+systemctl mask "$UNIT_NAME"
|
|
+[[ "$(systemctl is-enabled "$UNIT_NAME")" == masked ]]
|
|
+systemctl unmask "$UNIT_NAME"
|
|
+[[ "$(systemctl is-enabled "$UNIT_NAME")" == disabled ]]
|
|
+systemctl mask "$UNIT_NAME"
|
|
+[[ "$(systemctl is-enabled "$UNIT_NAME")" == masked ]]
|
|
+systemctl revert "$UNIT_NAME"
|
|
+[[ "$(systemctl is-enabled "$UNIT_NAME")" == disabled ]]
|
|
+systemctl mask --runtime "$UNIT_NAME"
|
|
+[[ "$(systemctl is-enabled "$UNIT_NAME")" == masked-runtime ]]
|
|
+# This should be a no-op without the --runtime switch
|
|
+systemctl unmask "$UNIT_NAME"
|
|
+[[ "$(systemctl is-enabled "$UNIT_NAME")" == masked-runtime ]]
|
|
+systemctl unmask --runtime "$UNIT_NAME"
|
|
+[[ "$(systemctl is-enabled "$UNIT_NAME")" == disabled ]]
|
|
+
|
|
+# add-wants/add-requires
|
|
+(! systemctl show -P Wants "$UNIT_NAME" | grep "systemd-journald.service")
|
|
+systemctl add-wants "$UNIT_NAME" "systemd-journald.service"
|
|
+systemctl show -P Wants "$UNIT_NAME" | grep "systemd-journald.service"
|
|
+(! systemctl show -P Requires "$UNIT_NAME" | grep "systemd-journald.service")
|
|
+systemctl add-requires "$UNIT_NAME" "systemd-journald.service"
|
|
+systemctl show -P Requires "$UNIT_NAME" | grep "systemd-journald.service"
|
|
+
|
|
+# set-property
|
|
+systemctl set-property "$UNIT_NAME" IPAccounting=yes MemoryMax=1234567
|
|
+systemctl cat "$UNIT_NAME"
|
|
+# These properties should be saved to a persistent storage
|
|
+grep -r "IPAccounting=yes" "/etc/systemd/system.control/${UNIT_NAME}.d/"
|
|
+grep -r "MemoryMax=1234567" "/etc/systemd/system.control/${UNIT_NAME}.d"
|
|
+systemctl revert "$UNIT_NAME"
|
|
+(! grep -r "IPAccounting=" "/etc/systemd/system.control/${UNIT_NAME}.d/")
|
|
+(! grep -r "MemoryMax=" "/etc/systemd/system.control/${UNIT_NAME}.d/")
|
|
+# Same stuff, but with --runtime, which should use /run
|
|
+systemctl set-property --runtime "$UNIT_NAME" CPUAccounting=no CPUQuota=10%
|
|
+systemctl cat "$UNIT_NAME"
|
|
+grep -r "CPUAccounting=no" "/run/systemd/system.control/${UNIT_NAME}.d/"
|
|
+grep -r "CPUQuota=10%" "/run/systemd/system.control/${UNIT_NAME}.d/"
|
|
+systemctl revert "$UNIT_NAME"
|
|
+(! grep -r "CPUAccounting=" "/run/systemd/system.control/${UNIT_NAME}.d/")
|
|
+(! grep -r "CPUQuota=" "/run/systemd/system.control/${UNIT_NAME}.d/")
|
|
+
|
|
+# Failed-unit related tests
|
|
+systemd-run --unit "failed.service" /bin/false
|
|
+systemctl is-failed failed.service
|
|
+systemctl --state=failed | grep failed.service
|
|
+systemctl --failed | grep failed.service
|
|
+systemctl reset-failed "fail*.service"
|
|
+(! systemctl is-failed failed.service)
|
|
+
|
|
+# clean
|
|
+systemctl restart "$UNIT_NAME"
|
|
+systemctl stop "$UNIT_NAME"
|
|
+# Check if the directories from *Directory= directives exist
|
|
+# (except RuntimeDirectory= in /run, which is removed when the unit is stopped)
|
|
+for path in /var/lib /var/cache /var/log /etc; do
|
|
+ [[ -e "$path/$UNIT_NAME" ]]
|
|
+done
|
|
+# Run the cleanup
|
|
+for what in "" configuration state cache logs runtime all; do
|
|
+ systemctl clean ${what:+--what="$what"} "$UNIT_NAME"
|
|
+done
|
|
+# All respective directories should be removed
|
|
+for path in /run /var/lib /var/cache /var/log /etc; do
|
|
+ [[ ! -e "$path/$UNIT_NAME" ]]
|
|
+done
|
|
+
|
|
+# --timestamp
|
|
+for value in pretty us µs utc us+utc µs+utc; do
|
|
+ systemctl show -P KernelTimestamp --timestamp="$value"
|
|
+done
|
|
+
|
|
+# Aux verbs & assorted checks
|
|
+systemctl is-active "*-journald.service"
|
|
+systemctl cat "*journal*"
|
|
+systemctl cat "$UNIT_NAME"
|
|
+systemctl help "$UNIT_NAME"
|
|
+
|
|
+# show/set-environment
|
|
# Make sure PATH is set
|
|
systemctl show-environment | grep -q '^PATH='
|
|
-
|
|
# Let's add an entry and override a built-in one
|
|
systemctl set-environment PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/testaddition FOO=BAR
|
|
-
|
|
# Check that both are set
|
|
systemctl show-environment | grep -q '^PATH=.*testaddition$'
|
|
systemctl show-environment | grep -q '^FOO=BAR$'
|
|
-
|
|
systemctl daemon-reload
|
|
-
|
|
# Check again after the reload
|
|
systemctl show-environment | grep -q '^PATH=.*testaddition$'
|
|
systemctl show-environment | grep -q '^FOO=BAR$'
|
|
-
|
|
# Check that JSON output is supported
|
|
systemctl show-environment --output=json | grep -q '^{.*"FOO":"BAR".*}$'
|
|
-
|
|
# Drop both
|
|
systemctl unset-environment FOO PATH
|
|
-
|
|
# Check that one is gone and the other reverted to the built-in
|
|
systemctl show-environment | grep '^FOO=$' && exit 1
|
|
systemctl show-environment | grep '^PATH=.*testaddition$' && exit 1
|
|
systemctl show-environment | grep -q '^PATH='
|
|
+# Check import-environment
|
|
+export IMPORT_THIS=hello
|
|
+export IMPORT_THIS_TOO=world
|
|
+systemctl import-environment IMPORT_THIS IMPORT_THIS_TOO
|
|
+systemctl show-environment | grep "^IMPORT_THIS=$IMPORT_THIS"
|
|
+systemctl show-environment | grep "^IMPORT_THIS_TOO=$IMPORT_THIS_TOO"
|
|
+systemctl unset-environment IMPORT_THIS IMPORT_THIS_TOO
|
|
+(! systemctl show-environment | grep "^IMPORT_THIS=")
|
|
+(! systemctl show-environment | grep "^IMPORT_THIS_TOO=")
|
|
|
|
echo OK >/testok
|
|
|